from network_socket import NetworkSocket

eth8020 = NetworkSocket()

#These will be the relays

def connect(ip, port, password):
    return eth8020.connect_socket(ip, port, password)

def disconnect():
    eth8020.close_socket()

def digital_command(command):

    parts = command.split(" ")     # Seperate the parts of the command
    message = None

    if parts[1] == "on":           # Are we turning the relay on or off
        message = '\x20'
    else:
        message = '\x21'

    message += chr(int(parts[0]))  # Which relay is it

    message += '\x00'              # 0 pulse time

    eth8020.write(message)         # send command and read back responce byte
    eth8020.read(1)

def get_states():
    command = '\x24'
    eth8020.write(command)          # send command and read back responce byte
    states = eth8020.read(3)
    print(states)
    st_str1 = ''.join('{0:04b}'.format(states[2], 'b'))
    st_str2 = ''.join('{0:08b}'.format(states[1], 'b'))
    st_str3 = ''.join('{0:08b}'.format(states[0], 'b'))
    print('Relay states 20->1 : ' + st_str1 + ' ' + st_str2 + ' ' + st_str3)

    command = '\x25'
    eth8020.write(command)
    states = eth8020.read(4)

    print('Digital inputs 8->1 : '+''.join('{0:08b}'.format(x, 'b') for x in states ))

    for index in range(1, 9):   # Get Analogue values
        command = '\x32'+chr(index)
        eth8020.write(command)
        an = bytearray(eth8020.read(2))
        val = an[0] << 8 | an[1]
        print('Analogue input {:d}: {:d}'.format(index, val))
